/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <stdlib.h>
#include <stdio.h>

#include <cuda.h>

#include "cpu_rpc_prot.h"
#include "cpu-server-driver-hidden.h"
#include "cpu-common.h"
#include "cpu-utils.h"


bool_t rpc_cudevicegetcount_1_svc(int_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuDeviceGetCount(&result->int_result_u.data);
    return 1;
}

bool_t rpc_cuinit_1_svc(int argp, int *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    *result = cuInit(argp);
    return 1;
}

bool_t rpc_cudrivergetversion_1_svc(int_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuDriverGetVersion(&result->int_result_u.data);
    return 1;
}

bool_t rpc_cudeviceget_1_svc(int ordinal, int_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuDeviceGet(&result->int_result_u.data, ordinal);
    return 1;
}

bool_t rpc_cudevicegetname_1_svc(int dev, str_result *result, struct svc_req *rqstp)
{
    result->str_result_u.str = malloc(128);
    printf("%s\n", __FUNCTION__);
    result->err = cuDeviceGetName(result->str_result_u.str, 128, dev);
    return 1;
}

bool_t rpc_cudevicetotalmem_1_svc(int dev, u64_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuDeviceTotalMem(&result->u64_result_u.u64, dev);
    return 1;
}

bool_t rpc_cudevicegetattribute_1_svc(int attribute, int dev, int_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuDeviceGetAttribute(&result->int_result_u.data, attribute, dev);
    return 1;
}

bool_t rpc_cudevicegetuuid_1_svc(int dev, uuid_result *result, struct svc_req *rqstp)
{
    CUuuid uuid;
    printf("%s\n", __FUNCTION__);
    result->err = cuDeviceGetUuid(&uuid, dev);
    if (result->err == 0) {
        memcpy(result->uuid_result_u.bytes, uuid.bytes, 16);
    }
    return 1;
}

bool_t rpc_cuctxgetcurrent_1_svc(ptr_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuCtxGetCurrent((struct CUctx_st**)&result->ptr_result_u.ptr);
    if ((void*)result->ptr_result_u.ptr != NULL) {
        unsigned int version = 0;
        cuCtxGetApiVersion((CUcontext)result->ptr_result_u.ptr, &version);
        printf("ctxapi version: %d\n", version);
    }
    return 1;
}

bool_t rpc_cuctxsetcurrent_1_svc(uint64_t ptr, int *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    *result = cuCtxSetCurrent((struct CUctx_st*)ptr);
    return 1;
}

bool_t rpc_cudeviceprimaryctxretain_1_svc(int dev, ptr_result *result,
                                          struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuDevicePrimaryCtxRetain((struct CUctx_st**)&result->ptr_result_u.ptr, dev);
    return 1;
}

bool_t rpc_cumodulegetfunction_1_svc(uint64_t module, char *name, ptr_result *result,
                                     struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuModuleGetFunction((CUfunction*)&result->ptr_result_u.ptr,
                                      (CUmodule)module, name);
    return 1;
}


bool_t rpc_cugetexporttable_1_svc(rpc_uuid rpc_uuid, ptr_result *result,
                                  struct svc_req *rqstp)
{
    void *exportTable = NULL;
    size_t tablesize = 0;
    CUuuid uuid;
    printf("%s\n", __FUNCTION__);
    if (rpc_uuid.rpc_uuid_val == NULL)
        return 0;

    memcpy(uuid.bytes, rpc_uuid.rpc_uuid_val, 16);
    if ((result->err = cuGetExportTable((const void**)&exportTable,
                                        (const CUuuid*)&uuid) != 0)) {
        return 1;
    }
    if (((uint32_t*)exportTable)[1] > 0) {
        tablesize = 8;
        for (int i=1; i<8; ++i) {
            if (((void**)exportTable)[i] == NULL) {
                tablesize = i;
                break;
            }
        }
    } else {
        tablesize = *((uint64_t*)exportTable)/8;
    }
    printf("\ttablesize = %lu\n", tablesize);
    printf("\tpost %p->%p\n", exportTable, *(void**)exportTable);

    if (!(uint64_t)cd_svc_hidden_add_table(exportTable, tablesize)) {
        fprintf(stderr, "\tfailed to add table!\n");
        return 0;
    }
    result->ptr_result_u.ptr = (uint64_t)exportTable;

    return 1;
}

bool_t rpc_cumemalloc_1_svc(uint64_t size, ptr_result *result,
                                     struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuMemAlloc_v2((CUdeviceptr*)&result->ptr_result_u.ptr, (size_t)size);
    return 1;
}

bool_t rpc_cuctxgetdevice_1_svc(int_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    result->err = cuCtxGetDevice((CUdevice*)&result->int_result_u.data);
    return 1;
}

bool_t rpc_cumemcpyhtod_1_svc(uint64_t dptr, mem_data hptr, int *result,
                                     struct svc_req *rqstp)
{
    printf("%s(%p,%p,%d)\n", __FUNCTION__, dptr, hptr.mem_data_val, hptr.mem_data_len);
    *result = cuMemcpyHtoD_v2((CUdeviceptr)dptr, hptr.mem_data_val,
                              hptr.mem_data_len);
    return 1;
}

bool_t rpc_culaunchkernel_1_svc(uint64_t f, unsigned int gridDimX, unsigned int gridDimY, unsigned int gridDimZ, unsigned int blockDimX, unsigned int blockDimY, unsigned int blockDimZ, unsigned int sharedMemBytes, uint64_t hStream, mem_data kernelParams, int* result, struct svc_req *rqstp)
{
    void *config[] = {
        CU_LAUNCH_PARAM_BUFFER_POINTER, kernelParams.mem_data_val,
        CU_LAUNCH_PARAM_BUFFER_SIZE,    &kernelParams.mem_data_len,
        CU_LAUNCH_PARAM_END};
    printf("%s\n", __FUNCTION__);
    *result = cuLaunchKernel((CUfunction)f, gridDimX, gridDimY, gridDimZ, blockDimX, blockDimY, blockDimZ, sharedMemBytes, (CUstream)hStream, NULL, config);
    return 1;

}

/* ################## START OF HIDDEN FUNCTIONS IMPL ######################## */

bool_t rpc_hidden_get_device_ctx_1_svc(int dev, ptr_result *result,
                                     struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);

    result->err = ((int(*)(void**,int))(cd_svc_hidden_get(0,1)))
                                        ((void**)&result->ptr_result_u.ptr, dev);
    return 1;
}

/* This function loads the module (the device code)
 * It could be replaced by cuModuleLoad which loads a module via a path
 * string. However, this seems to only work for cubin files that were
 * compiled using "nvcc -cubin" or extracted from a fatbinary using
 * "cuobjdump -xelf". When this returns 200 or 300 the cubin may be
 * compiled for the wrong compute capabilities (e.g. Pascal needs sm_61 and
 * Turing needs sm_75).
 */
bool_t rpc_hidden_get_module_1_svc(uint64_t arg2, uint64_t arg3,
                                   uint64_t arg4, int arg5,
                                   ptr_result *result, struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    //TODO: make a parameter. Probably must be globally stored somehow
    //      thread-safety may be an issue
    //char str[] = "/home/eiling/projects/cricket/tests/test_api.1.sm_61.cubin";
    //result->err = cuModuleLoad((CUmodule*)&result->ptr_result_u.ptr, str);

    result->err = ((int(*)(void**,void*,uint64_t,uint64_t,int))
                   (cd_svc_hidden_get(0,5)))
                   ((void**)&result->ptr_result_u.ptr, &arg2, arg3,
                    arg4, arg5);
    return 1;
}

bool_t rpc_hidden_1_1_1_svc(ptr_result *result,
                            struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    void *l_arg1 = NULL;

    ((int(*)(void**, void**))(cd_svc_hidden_get(1,1)))
                             (&l_arg1, (void**)&result->ptr_result_u.ptr);
    result->err = 0;
    return 1;
}

bool_t rpc_hidden_1_3_1_svc(uint64_t arg1, uint64_t arg2, void* unused,
                            struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);

    ((void(*)(uint64_t, uint64_t))(cd_svc_hidden_get(1,3)))
                             (arg1, arg2);
    return 1;
}

bool_t rpc_hidden_1_5_1_svc(ptr_result *result,
                            struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);
    void *l_arg1 = NULL;

    ((int(*)(void**, void**))(cd_svc_hidden_get(1,5)))
                             (&l_arg1, (void**)&result->ptr_result_u.ptr);
    result->err = 0;
    return 1;
}

bool_t rpc_hidden_2_1_1_svc(uint64_t arg1, void* unused,
                            struct svc_req *rqstp)
{
    printf("%s\n", __FUNCTION__);

    ((void(*)(uint64_t))(cd_svc_hidden_get(2,1)))
                             (arg1);
    return 1;
}

bool_t rpc_hidden_3_0_1_svc(int arg1, uint64_t arg2, uint64_t arg3,
                            int *result, struct svc_req *rqstp)
{
    printf("%s(%d, %p, %p)\n", __FUNCTION__, arg1, arg2, arg3);
    void *fptr = cd_svc_hidden_get(3,0);
    *result = ((int(*)(int, void*, void*))(fptr))
                      (arg1, &arg2, &arg3);
    return 1;
}

bool_t rpc_hidden_3_2_1_svc(int arg2, uint64_t arg3, mem_result *result,
                            struct svc_req *rqstp)
{
    result->mem_result_u.data.mem_data_val = NULL;
    result->mem_result_u.data.mem_data_len = 0x58;
    printf("%s(%d, %p)\n", __FUNCTION__, arg2, arg3);
    //printf("\tppre %s(nh->%p, %d, nh->%p->%p)\n", __FUNCTION__, result->ptr_result_u.ptr, arg2, (void*)arg3, *(void**)arg3);
    void *fptr = cd_svc_hidden_get(3,2);
    result->err = ((int(*)(void**, int, void*))(fptr))
                             ((void**)&result->mem_result_u.data.mem_data_val, arg2, &arg3);
    void **res = ((void**)result->mem_result_u.data.mem_data_val);
    if (res != 0)
        printf("\t%p, @0x30: %p, @0x40: %p->%p\n", res, res[6], res[8], *(void**)res[8]);
    //printf("\tppost %s(nh->%p, %d, nh->%p->%p)\n", __FUNCTION__, result->ptr_result_u.ptr, arg2, (void*)arg3, *(void**)arg3);
    //printf("\terr: %d, result: %p\n", result->err, result->ptr_result_u.ptr);
    return 1;
}

